- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnClip Class Reference

# OpenMayaAnim - API module for animation | FunctionSet classes

Search for all occurrences

## Detailed Description

clip function set

Maya uses animation clips as the building block of its nonlinear animation system, "Trax". An animation clip allows the user to bundle a set of animation curves independent of time so that they can be reused multiple times, with different timing then the original clip.

Character sets (MFnCharacter) are integral to Maya's clip architecture, since a clip contains whatever attributes of the character were animated when the clip was created. For more information on character sets, refer to the MFnCharacter documentation.

Clips in maya can be of two types: source clips and scheduled clips. In the Maya UI, source clips are visible in the Visor while scheduled clips are visible in Trax. A source clip contains the animation curves for the clip. A scheduled clip contains data about the placement of an instance of a source clip in the Maya timeline. In this context, an "instance" means that the animation curves from the source clip are shared by the scheduled clip. Scheduled clips never contain their own animation curves, they always refer to a source clip's curves.

For example, if you create a clip called "run" in maya that lasts from frames 1-20, a source clip node will be created with a start of 1, a duration of 19, and dependency graph connections to all of the animation curves that make up the "run". If you then place an instance of the run clip at frame 5 and another instance of the run clip at frame 20, you have 2 scheduled clips: one with a start frame of 5 and one with a start frame of 20. As mentioned in the previous paragraph, only a single set of animation curves exist for the run regardless of the number of times the run is scheduled.

Trax also allows you to create "blends" between clips, which enable you to control the transition between the clips. A blend is represented in the dependency graph by an "animBlendInOut" node, which uses an animation curve to determine the transition type.

In the dependency graph, when a character has animation clips, the character node will always be connected to a "clipLibrary" node and a "clipScheduler" node. The clipLibrary node is connected to all of the source clips and their animation curves. The clipScheduler node is connected to the scheduled clips and blends. It is the clipScheduler that computes the final animation by looking at the placement and overlap of the clips and feeding the attribute data back into the character set.

To create a source clip, the typical steps are:

1. If the attributes are not already in a character, create a character containing the attributes.
2. Create a source clip using MFnClip::createSourceClip
3. Attach the clip to a character using MFnCharacter::attachSourceToCharacter
4. Attach animation curves to the clip using MFnCharacter::addCurveToClip

To create a scheduled clip so that it appears in the Trax Editor, the typical steps are:

1. Create an instanced animClip node using MFnClip::createInstancedClip, and associate it with the source clip that you want to instance.
2. Attach the clip instance to the character using MFnCharacter::attachInstanceToCharacter

Examples:

  createClipCmd.cpp.

`#include <MFnClip.h>`

Inheritance diagram for MFnClip:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnClip ()
| Destructor.
| MFnClip ()
| Default constructor.
| MFnClip (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
MObject | createSourceClip (const MTime &sourceStart, const MTime &sourceDuration, MDGModifier &dgMod, MStatus *ReturnStatus=NULL)
| Creates a source clip node and associates it with this function set.
MObject | createInstancedClip (MObject &sourceClip, const MTime &start, MDGModifier &dgMod, MStatus *ReturnStatus=NULL, bool absolute=1, double postCycle=0.0, double weight=1.0, double scale=1.0, double preCycle=0.0)
| Creates an instance of a clip that will be viewable in the Trax editor.
bool | isInstancedClip (MStatus *ReturnStatus=NULL)
| Return true or false as to whether the clip node represents the source clip or an instanced clip.
bool | isPose (MStatus *ReturnStatus=NULL)
| Return true or false as to whether the clip node represents a pose.
MObject | sourceClip (MStatus *ReturnStatus=NULL)
| Return the source clip associated with the MFnClip's clip.
double | getPreCycle (MStatus *ReturnStatus=NULL)
| Return the value of this clip's pre cycle attribute.
double | getPostCycle (MStatus *ReturnStatus=NULL)
| Return the value of this clip's post cycle attribute.
double | getCycle (MStatus *ReturnStatus=NULL)
| This method is obsolete.
double | getWeight (MStatus *ReturnStatus=NULL)
| Return the value of this clip's weight attribute.
double | getScale (MStatus *ReturnStatus=NULL)
| Return the value of this clip's scale attribute.
bool | getAbsolute (MStatus *ReturnStatus=NULL)
| This method is obsolete.
bool | getEnabled (MStatus *ReturnStatus=NULL)
| Return the value of this clip's enable attribute.
MTime | getStartFrame (MStatus *ReturnStatus=NULL)
| Return the value of this clip's start frame.
MTime | getSourceStart (MStatus *ReturnStatus=NULL)
| Return the value of the start frame of this clip's source clip.
MTime | getSourceDuration (MStatus *ReturnStatus=NULL)
| Return the value of the start frame of this clip's source duration.
MStatus | getMemberAnimCurves (MObjectArray &curves, MPlugArray &associatedAttrs)
| Return two arrays: the first contains the animCurves associated with this clip.
MStatus | getAbsoluteChannelSettings (MIntArray &absoluteChannels)
| Return an array indicating which channels of the clip are absolute and which are relative.
int | getTrack (MStatus *ReturnStatus=NULL)
| Return the track number for the clip.
MStatus | setPoseClip (bool state, MDGModifier *mod=NULL)
| Specify whether or not this clip node should be tagged as a pose rather than a clip.
MStatus | setPreCycle (double cycle, MDGModifier *mod=NULL)
| Specify the pre cycle value for the clip.
MStatus | setPostCycle (double cycle, MDGModifier *mod=NULL)
| Specify the post cycle value for the clip.
MStatus | setCycle (double cycle, MDGModifier *mod=NULL)
| This method is obsolete.
MStatus | setWeight (double wt, MDGModifier *mod=NULL)
| Specify a weight value for the clip.
MStatus | setScale (double scale, MDGModifier *mod=NULL)
| Specify a scale value for the clip.
MStatus | setAbsolute (bool abs, MDGModifier *mod=NULL)
| This method is obsolete.
MStatus | setEnabled (bool val, MDGModifier *mod=NULL)
| Specify whether or not the clip is enabled.
MStatus | setStartFrame (const MTime &start, MDGModifier *mod=NULL)
| Specify the start frame for the instanced clip.
MStatus | setSourceData (const MTime &start, const MTime &duration, MDGModifier *mod=NULL)
| Specify the start frame and duration for the source clip associated with this clip.
MStatus | setTrack (int index, MDGModifier *mod=NULL)
| Specify the one-based track number for the clip.
MStatus | setAbsoluteChannelSettings (const MIntArray &absoluteChannels, MDGModifier *mod=NULL)
| Set which channels of the clip are absolute and which are relative.
| MFnClip (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnClip | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnClip | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kClip.

Reimplemented from MFnDependencyNode.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnClip".

Reimplemented from MFnDependencyNode.

MObject createSourceClip | ( | const MTime & | sourceStart,
|  | const MTime & | sourceDuration,
|  | MDGModifier & | dgMod,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a source clip node and associates it with this function set.

Each animation clip has a single source clip, which defines the startFrame and duration of the clip's animation curves. The startFrame and duration act as a window onto the animation curves, defining the range of animation that is considered part of the clip. After a source clip node is created, it can be passed to a MFnCharacter along with the clip animCurves in order to associate the clip with the character.

Parameters:

  [in] | sourceStart | time on clip animCurves that represents clip start
  [in] | sourceDuration | time extent of the clip
  [in] | dgMod | command modifier used for undo and redo
  [out] | ReturnStatus | return status

Returns:
  The newly created clip.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed
  - MS::kInsufficientMemory out of memory

Examples:
  createClipCmd.cpp.

MObject createInstancedClip | ( | MObject & | sourceClip,
|  | const MTime & | start,
|  | MDGModifier & | dgMod,
|  | MStatus * | ReturnStatus = `NULL`,
|  | bool | absolute = `1`,
|  | double | postCycle = `0.0`,
|  | double | weight = `1.0`,
|  | double | scale = `1.0`,
|  | double | preCycle = `0.0`
| ) |  |

Search for all occurrences

Creates an instance of a clip that will be viewable in the Trax editor.

Parameters:

  [in] | sourceClip | the source clip node
  [in] | start | start frame where the instance will be scheduled
  [in] | dgMod | command modifier used for undo and redo
  [in] | ReturnStatus | return status
  [in] | absolute | whether the clip is absolute (1) or relative (0)
  [in] | preCycle | pre cycle for the clip
  [in] | postCycle | post cycle for the clip
  [in] | weight | weight for the clip
  [in] | scale | scale for the clip

Returns:
  The newly created clip.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure invalid source clip was provided
  - MS::kInsufficientMemory out of memory

Examples:
  createClipCmd.cpp.

bool isInstancedClip | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return true or false as to whether the clip node represents the source clip or an instanced clip.

All clips maintained by the clipScheduler node and visible in the TraX editor are instanced clips. All clips maintained by the clipLibrary node and visible in the Visor are non-instanced clips, also called "Source Clips". Each instanced clip has a corresponding source clip.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  True or false as to whether the clip is an instanced clip.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

bool isPose | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return true or false as to whether the clip node represents a pose.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  True or false as to whether the clip is a pose.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MObject sourceClip | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the source clip associated with the MFnClip's clip.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  MObject containing the associated source clip.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kObjectDoesNotExist this clip does not have an associated source clip
  - MS::kFailure this function set does not have a valid clip object

double getPreCycle | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of this clip's pre cycle attribute.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's pre cycle attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

double getPostCycle | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of this clip's post cycle attribute.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's post cycle attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

double getCycle | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

This method is obsolete.

Deprecated:
  Use the method MFnClip::getPostCycle instead.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's cycle attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

double getWeight | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of this clip's weight attribute.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's weight attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

double getScale | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of this clip's scale attribute.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's scale attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

bool getAbsolute | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

This method is obsolete.

Deprecated:
  Use the method MFnClip::getAbsoluteChannelSettings instead.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's offset attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

bool getEnabled | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of this clip's enable attribute.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's enable attribute.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MTime getStartFrame | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of this clip's start frame.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's start frame.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MTime getSourceStart | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of the start frame of this clip's source clip.

The sourceStart and sourceDuration define the region of the animCurve that is treated as the clip.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's source start frame.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object
  - MS::kObjectDoesNotExist this clip does not have an associated source clip

MTime getSourceDuration | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the value of the start frame of this clip's source duration.

The sourceStart and sourceDuration define the region of the animCurve that is treated as the clip.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The value of this clip's source duration.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object
  - MS::kObjectDoesNotExist this clip does not have an associated source clip

MStatus getMemberAnimCurves | ( | MObjectArray & | curves,
|  | MPlugArray & | associatedAttrs
| ) |  |

Search for all occurrences

Return two arrays: the first contains the animCurves associated with this clip.

The second contains the character member that is driven by this animCurve.

Parameters:

  [out] | curves | array to store the result curves
  [out] | associatedAttrs | array to store the character members

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object
  - MS::kObjectDoesNotExist this clip does not have an associated source clip

MStatus getAbsoluteChannelSettings | ( | MIntArray & | absoluteChannels | ) |

Search for all occurrences

Return an array indicating which channels of the clip are absolute and which are relative.

The length of the array is equal to the members in the character. A value of one in the array indicates absolute and a value of 0 indicates relative.

Parameters:

  [out] | absoluteChannels | array to store the result

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

int getTrack | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the track number for the clip.

Track indices are one-based. If a track index of zero is returned, it indicates that a track has not yet been assigned to the clip.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The index of this clip's track

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this clip is a source clip and does not have a track
  - MS::kObjectDoesNotExist this function set does not have a valid clip object

MStatus setPoseClip | ( | bool | state,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify whether or not this clip node should be tagged as a pose rather than a clip.

By default, clip nodes are not poses.

Parameters:

  [in] | state | true, to tag the clip as a pose
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setPreCycle | ( | double | cycle,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify the pre cycle value for the clip.

Parameters:

  [in] | cycle | cycle value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setPostCycle | ( | double | cycle,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify the post cycle value for the clip.

Parameters:

  [in] | cycle | cycle value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setCycle | ( | double | cycle,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

This method is obsolete.

Deprecated:
  Use the method MFnClip::setPostCycle instead.

Parameters:

  [in] | cycle | cycle value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setWeight | ( | double | wt,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify a weight value for the clip.

Parameters:

  [in] | wt | weight value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setScale | ( | double | scale,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify a scale value for the clip.

Parameters:

  [in] | scale | scale value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setAbsolute | ( | bool | abs,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

This method is obsolete.

Deprecated:
  Use the method MFnClip::setAbsoluteChannelSettings instead.

Parameters:

  [in] | abs | true if absolute, false if relative
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setEnabled | ( | bool | val,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify whether or not the clip is enabled.

Note: should not be called for source clips since the enabled attribute is ignored on source clips.

Parameters:

  [in] | val | enable value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setStartFrame | ( | const MTime & | start,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify the start frame for the instanced clip.

Note: should not be called for source clips since the start frame attribute is ignored on source clips.

Parameters:

  [in] | start | start frame value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object

MStatus setSourceData | ( | const MTime & | start,
|  | const MTime & | duration,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify the start frame and duration for the source clip associated with this clip.

Parameters:

  [in] | start | source start frame value
  [in] | duration | source duration value
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object
  - MS::kObjectDoesNotExist this clip does not have an associated source clip

MStatus setTrack | ( | int | trackIndex,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Specify the one-based track number for the clip.

Parameters:

  [in] | trackIndex | the track number for the clip
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid clip object
  - MS::kObjectDoesNotExist clip track value cannot be set

MStatus setAbsoluteChannelSettings | ( | const MIntArray & | absoluteChannels,
|  | MDGModifier * | mod = `NULL`
| ) |  |

Search for all occurrences

Set which channels of the clip are absolute and which are relative.

The length of the specified array should be equal to the number of members in the character. A value of one in the array indicates absolute and a value of 0 indicates relative.

Parameters:

  [in] | absoluteChannels | array containing the absolute channels to be set
  [in] | mod | modifier to use when calling this method from commands that support undo

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kObjectDoesNotExist this function set does not have a valid clip object

MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip
MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip MFnClip